<?php
/**
* ⥸塼륰դΥΡɤ륯饹
*
* PHP version 5
*
* @package    core
* @author     stk2k <stk2k@sazysoft.com>
* @copyright  2008 stk2k, sazysoft
*/

class charcoal_ModuleGraphNode 
{
	var $_node_name;
	var $_module_name;
	var $_transitions;
	var $_context_values;

	/*
	 *    󥹥ȥ饯
	 */
	public function __construct()
	{
		$this->_module = NULL;
		$this->_transitions = NULL;
		$this->_context_values = NULL;
	}

	/*
	 * Ρ̾
	 */
	public function getNodeName()
	{
		return $this->_node_name;
	}

	/*
	 * ⥸塼̾
	 */
	public function getModuleName()
	{
		return $this->_module_name;
	}

	/*
	 * 襭
	 */
	public function getTransitionKeys()
	{
		return array_keys( $this->_transitions );
	}

	/*
	 * 
	 */
	public function getNextNode( $transition_key )
	{
		return isset($this->_transitions[ $transition_key ]) ? $this->_transitions[ $transition_key ] : NULL;
	}

	/*
	 * Ρɤ
	 */
	public function create( $node_name, $node_config )
	{
		log_info( "system",  "Ρ[$node_name]ޤ", __FILE__, __LINE__ );

		// 
		if ( !isset($node_config[ "next" ]) ){
			throw new charcoal_ModuleGraphConfigException( "$node_name/next", "mandatory" );
		}
		$transitions = $node_config[ "next" ];

		// ⥸塼̾
		if ( !isset($node_config[ "module_name" ]) ){
			throw new charcoal_ModuleGraphConfigException( "$node_name/module_name", "mandatory" );
		}
		$module_name = $node_config[ "module_name" ];

		// ⥸塼륳ƥͤ
		$context_values = isset($node_config[ "context" ]) ? $node_config[ "context" ] : NULL;

		$this->_node_name = "$node_name";
		$this->_module_name = $module_name;
		$this->_transitions = $transitions;
		$this->_context_values = $context_values;
	}

	/*
	 * ƥͤ򥤥󥸥Ȥ
	 */
	private function injectContext( charcoal_ProcedureContext $context )
	{
		if ( !$this->_context_values ){
			return;
		}

		$node_name = $this->_node_name;
		foreach( $this->_context_values as $key => $value ){
			log_debug( 'system', "Ρ[$node_name][$key:$value]", __FILE__, __LINE__ );
			$context->set( $key, $value );
			log_debug( 'system', "Ρ[$node_name]ǥƥ[$key:$value]injectޤ", __FILE__, __LINE__ );
		}
	}

	/*
	 * Ρɤ¹Ԥ
	 */
	public function execute( charcoal_Request $request, charcoal_ProcedureContext $context, charcoal_Response $response )
	{
		try{
			// ƥͤ򥤥󥸥Ȥ
			$this->injectContext($context);

			// Ρ̾ȥ⥸塼̾
			$node_name = $this->_node_name;
			$module_name = $this->_module_name;

			log_info( "system",  "Ρ[$node_name]¹Ԥޤ", __FILE__, __LINE__ );

			// ⥸塼Υ
			$module = charcoal_ModuleFactory::create( $module_name );

			// ⥸塼μ¹
			log_info( "system",  "⥸塼[$module_name]¹Ԥޤ", __FILE__, __LINE__ );

	//			try{
				$transition_key = $module->execute( $request, $context, $response );

	/*			}
			catch( Exception $e ){
				// 㳰
				$exception_name = get_class($e);
				log_info( "system",  "㳰[$exception_name]catchޤ", __FILE__, __LINE__ );
				$transition_key = "exception";
				// ⥸塼륳ƥȤ㳰Ƥ򥳥ԡ
				$context->set( "exception", $e );
			}
	*/

			log_info( "system",  "⥸塼[$module_name]¹Ԥޤ=[$transition_key]", __FILE__, __LINE__ );

			return $transition_key;
		}
		catch ( Exception $e ){
			throw new charcoal_ModuleGraphNodeException( $this, "ModuleGraphNode#execute() failed", $e );
		}
	}
}
